//
//  Copyright (c) 2005 Joël Amblard - joel.amblard_NOSPAM_wanadoo.fr (replace _NOSPAM_ by @)
//
//   This program is free software; you can redistribute it and/or modify 
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version. 

import javax.swing.*;
import java.awt.event.WindowAdapter ;
import java.awt.event.WindowEvent ;
import java.util.ResourceBundle ;
import java.io.File ;


public class edugraphe extends JFrame {
	
	zone Z ; 	
	JMenuBar mainMenuBar = new JMenuBar() ;
	protected JMenu fileMenu , createMenu , changeMenu , windowMenu , helpMenu ;
	protected JCheckBoxMenuItem cbMenuItem , checkRep , checkQuad , checkTool , checkDial ;
	protected ResourceBundle resbundle  = dessin.RB ;
	static String[] Args ;

    public static void main (String args[]) {
		System.setProperty("apple.laf.useScreenMenuBar", "true") ;
		Args = args ;
		edugraphe g = new edugraphe(args) ;
    }
	
	WindowAdapter windowListener = new WindowAdapter() {
		public void windowOpened(WindowEvent we) {
			Z.GR.clear() ; Z.o = Z.od = null ; 
			dessin.setGraphics(Z.getGraphics()) ; dessin.Z = Z ; dessin.D = Z.D ;
			File f = (Args.length > 0) ? new File(Args[0]) : null ;
			if ((f == null) || !f.exists()) Z.nouveau_def() ;
			else { Z.readFile(f) ; Z.setFile(f) ; }
			checkTool.setSelected(Z.T.isVisible()) ;
			checkDial.setSelected(Z.D.vis) ;
			dessin.setFont(dessin.FONT_PLAIN) ;
			Z.select() ;
			
		}
		
		public void windowClosing(WindowEvent we) { System.exit(0) ; }
		
	} ;

	public edugraphe(String args[]) {
		
		super("") ;
		
		// look and feel
		
		// layout
		getContentPane().add(Z = new zone(this) , "Center") ;
		setSize(Z.getPreferredSize()) ;
		setTitle(resbundle.getString("frameConstructor")) ;
				
		// menus
		setJMenuBar(mainMenuBar) ;
		mainMenuBar.add(fileMenu  = new JMenu(resbundle.getString("fileMenu"))) ;
		fileMenu.add(new JMenuItem(Z.newAction)) ;
		fileMenu.add(new JMenuItem(Z.openAction)) ;
		fileMenu.addSeparator() ;
		fileMenu.add(new JMenuItem(Z.saveAction)) ;
		fileMenu.add(new JMenuItem(Z.saveAsAction)) ;
		fileMenu.add(new JMenuItem(Z.printAction)) ;
		fileMenu.add(new JMenuItem(Z.pageAction)) ;
		fileMenu.add(new JMenuItem(Z.photoAction)) ;
		fileMenu.addSeparator() ;
		fileMenu.add(new JMenuItem(Z.aboutAction)) ;
		fileMenu.addSeparator() ;
		fileMenu.add(new JMenuItem(Z.quitAction)) ;
		
		mainMenuBar.add(createMenu = new JMenu(resbundle.getString("createMenu"))) ;
		createMenu.add(new JMenuItem(Z.pointAction)) ;
		createMenu.add(new JMenuItem(Z.pointOnCurveAction)) ;
		createMenu.add(new JMenuItem(Z.intersectionAction)) ;
		createMenu.add(new JMenuItem(Z.markAction)) ;
		createMenu.addSeparator() ;
		createMenu.add(new JMenuItem(Z.lineAction)) ;
		createMenu.add(new JMenuItem(Z.tangentAction)) ;
		createMenu.addSeparator() ;
		createMenu.add(new JMenuItem(Z.curveAction)) ;
		createMenu.add(new JMenuItem(Z.eulerAction)) ;
		createMenu.addSeparator() ;
		createMenu.add(new JMenuItem(Z.recSequenceAction)) ;
		createMenu.add(new JMenuItem(Z.genSequenceAction)) ;
		createMenu.add(new JMenuItem(Z.equationAction)) ;
		createMenu.addSeparator() ;
		createMenu.add(new JMenuItem(Z.domainAction)) ;
		// décommenter les deux lignes suivantes pour utiliser l'objet text
		createMenu.addSeparator() ;
		createMenu.add(new JMenuItem(Z.textAction)) ;

		mainMenuBar.add(changeMenu = new JMenu(resbundle.getString("changeMenu"))) ;
		changeMenu.add(new JMenuItem(Z.selectAction)) ;
		changeMenu.add(new JMenuItem(Z.deleteAction)) ;
		changeMenu.add(new JMenuItem(Z.clearAction)) ;

		mainMenuBar.add(windowMenu = new JMenu(resbundle.getString("windowMenu"))) ;
		windowMenu.add(new JMenuItem(Z.prefsAction)) ;
		windowMenu.add(new JMenuItem(Z.aspectAction)) ;
		windowMenu.addSeparator() ;
		checkRep = new JCheckBoxMenuItem(Z.repAction) ; 
		checkRep.setSelected(Z.repereVisible) ;
		windowMenu.add(checkRep) ; 
		checkQuad = new JCheckBoxMenuItem(Z.quadAction) ; 
		checkQuad.setSelected(Z.quadrillageVisible) ;
		windowMenu.add(checkQuad) ;
		windowMenu.add(new JMenuItem(Z.normAction)) ;
		windowMenu.addSeparator() ;
		checkTool = new JCheckBoxMenuItem(Z.toolAction) ; 
		windowMenu.add(checkTool) ;
		checkDial = new JCheckBoxMenuItem(Z.dialAction) ; 
		windowMenu.add(checkDial) ;
		windowMenu.addSeparator() ;
		windowMenu.add(new JMenuItem(Z.zoomAction)) ;
		windowMenu.add(new JMenuItem(Z.zoomPAction)) ;
		windowMenu.add(new JMenuItem(Z.zoomMAction)) ;

		mainMenuBar.add(helpMenu = new JMenu(resbundle.getString("helpMenu"))) ;
		helpMenu.add(new JMenuItem(Z.helpAction)) ;

		addWindowListener(windowListener) ;
		setVisible(true) ;
	}

}
